/* downloaded from web */
//#include <math.h>
//#include <stdio.h>
//#include <string.h>
#include "stdafx.h"

#include "base64.h"
#include <cstring>

inline int getPosition( char buf );

static const unsigned char *b64_tbl = (const unsigned char*) "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
static const unsigned char b64_pad = '=';




inline int getPosition( char buf )
{

	if( buf > 96 )		// [a-z]
		return (buf - 71);
	else if( buf > 64 )		// [A-Z]
		return (buf - 65);
	else if( buf > 47 )		// [0-9]
		return (buf + 4);
	else if( buf == 43 )
		return 63;
	else				// buf == '/'
		return 64;
}


// Returns the total number of bytes decoded
int b64_decode_mio ( char *dest,  char *src, size_t size )
{
	char *temp = dest;
	char *end = dest + size;

	for (;;)
	{
		int a;
		int b;
		int t1,t2,t3,t4;

		if (!(t1 = *src++) || !(t2 = *src++) || !(t3 = *src++) || !(t4 = *src++))
			return (int)(temp-dest);

		if (t1 == 61 || temp >= end)		// if == '='
			return(int)(temp-dest);

		if( t1 > 96 )		// [a-z]
			a = (t1 - 71);
		else if( t1 > 64 )		// [A-Z]
			a = (t1 - 65);
		else if( t1 > 47 )		// [0-9]
			a = (t1 + 4);
		else if( t1 == 43 )
			a = 62;
		else				// src[0] == '/'
			a = 63;     


		if( t2 > 96 )		// [a-z]
			b = (t2 - 71);
		else if( t2 > 64 )		// [A-Z]
			b = (t2 - 65);
		else if( t2 > 47 )		// [0-9]
			b = (t2 + 4);
		else if( t2 == 43 )
			b = 62;
		else				// src[0] == '/'
			b = 63;     

		*temp++ = ( a << 2) | ( b >> 4);

		if (t3 == 61 || temp >= end)
			return (int)(temp-dest);;

		if( t3 > 96 )		// [a-z]
			a = (t3 - 71);
		else if( t3 > 64 )		// [A-Z]
			a = (t3 - 65);
		else if( t3 > 47 )		// [0-9]
			a = (t3 + 4);
		else if( t3 == 43 )
			a = 62;
		else				// src[0] == '/'
			a = 63;     

		*temp++ = ( b << 4) | ( a >> 2);

		if (t4 == 61 || temp >= end)
			return (int)(temp-dest);;

		if( t4 > 96 )		// [a-z]
			b = (t4 - 71);
		else if( t4 > 64 )		// [A-Z]
			b = (t4 - 65);
		else if( t4 > 47 )		// [0-9]
			b = (t4 + 4);
		else if( t4 == 43 )
			b = 62;
		else				// src[0] == '/'
			b = 63;    

		*temp++ = ( a << 6) | ( b );
	}
}
